Index: /LMDZ4/trunk/libf/phylmd/write_histmthNMC.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/write_histmthNMC.h	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/write_histmthNMC.h	(revision 644)
@@ -5,54 +5,140 @@
       IF (ok_mensuel) THEN
 c
-      ndex2d = 0
-      ndex3d = 0
+       ndex3d = 0
+       itau_w = itau_phy + itap
+ccc
+c  Champs interpolles sur des niveaux de pression du NMC
 c
-c Champs 2D:
+c     PARAMETER(nout=3) !nout=1 : day; =2 : mth; =3 : NMC
+ccc
+      IF(type_run.EQ."CLIM".OR.type_run.EQ."ENSP") THEN
+ccc
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,tsumSTD(:,:,2),
+     $      zx_tmp_3d)
+       CALL histwrite(nid_nmc,"temp",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
 c
-
-        zsto = dtime
-        zout = dtime * ecrit_mth
-        itau_w = itau_phy + itap
-
-      i = NINT(zout/zsto)
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,phisumSTD(:,:,2),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"phi",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
 c
-c  Champs interpolles sur des niveaux de pression du NMC
-c110304 BEG
-      DO k=1, nlevSTD
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,qsumSTD(:,:,2),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"q",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
 c
-         bb=clevSTD(k)
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,rhsumSTD(:,:,2),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"rh",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
 c
-         IF(k.GE.2) THEN
-          aa=clevSTD(k)
-          bb=aa(1:lnblnk1(aa))
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,usumSTD(:,:,2),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"u",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,vsumSTD(:,:,2),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"v",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+ccc
+      ELSE IF(type_run.EQ."AMIP".OR.type_run.EQ."CFMI") THEN
+ccc
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,tsumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"temp",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,phisumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"phi",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,qsumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"q",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,rhsumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"rh",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,usumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"u",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,vsumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"v",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,wsumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"w",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+       DO k=1, nlevSTD
+        DO i=1, klon
+         IF(tnondef(i,k,3).NE.1.E+20) THEN
+          zx_tmp_fi3d(i,k) = (100.*tnondef(i,k,3))/FLOAT(ecrit_hf2mth)
+         ELSE
+          zx_tmp_fi3d(i,k) = 1.E+20
          ENDIF
+        ENDDO
+       ENDDO !k=1, nlevSTD
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, tlevSTD(:,k),zx_tmp_2d)
-      CALL histwrite(nid_nmc,"t"//bb,itau_w,zx_tmp_2d,
-     $       iim*jjmp1,ndex2d)
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+       CALL histwrite(nid_nmc,"psbg",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, philevSTD(:,k),zx_tmp_2d)
-      CALL histwrite(nid_nmc,"phi"//bb,itau_w,zx_tmp_2d,
-     $       iim*jjmp1,ndex2d)
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,uvsumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"uv",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, qlevSTD(:,k),zx_tmp_2d)
-      CALL histwrite(nid_nmc,"q"//bb,itau_w,zx_tmp_2d,
-     $       iim*jjmp1,ndex2d)
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,vqsumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"vq",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, rhlevSTD(:,k),zx_tmp_2d)
-      CALL histwrite(nid_nmc,"rh"//bb,itau_w,zx_tmp_2d,
-     $       iim*jjmp1,ndex2d)
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,vTsumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"vT",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, ulevSTD(:,k),zx_tmp_2d)
-      CALL histwrite(nid_nmc,"u"//bb,itau_w,zx_tmp_2d,
-     $       iim*jjmp1,ndex2d)
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1, wqsumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"wq",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, vlevSTD(:,k),zx_tmp_2d)
-      CALL histwrite(nid_nmc,"v"//bb,itau_w,zx_tmp_2d,
-     $       iim*jjmp1,ndex2d)
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,vphisumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"vphi",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
 c
-      ENDDO !k=1, nlevSTD
-ccc
-c110304 END
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,wTsumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"wT",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,u2sumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"uxu",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,v2sumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"vxv",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,T2sumSTD(:,:,3),
+     $     zx_tmp_3d)
+       CALL histwrite(nid_nmc,"TxT",itau_w,zx_tmp_3d,
+     $       iim*jjmp1*nlevSTD,ndex3d)
+c
+      ENDIF !type_run
 c
       if (ok_sync) then
Index: /LMDZ4/trunk/makegcm
===================================================================
--- /LMDZ4/trunk/makegcm	(revision 643)
+++ /LMDZ4/trunk/makegcm	(revision 644)
@@ -729,7 +729,11 @@
       \mv $libf/grid/dimensions90.tmp $libf/grid/dimensions90.h
 endif
-sed -e 's/^c/\!/' -e 's/^     s/  \&/' $libf/dyn3d/paramet.h >! $libf/dyn3d/paramet90.tmp
+sed -n -e 's/^c/\!/' -e '1 h' -e '2,$ H' -e '$ { x ; s/\n     s/ \&\n     \& /g ; p }' $libf/dyn3d/paramet.h >! $libf/dyn3d/paramet90.tmp
 if ( ! -f $libf/dyn3d/paramet90.h || `diff $libf/dyn3d/paramet90.tmp $libf/dyn3d/paramet90.h | wc -w` ) then
       \mv $libf/dyn3d/paramet90.tmp $libf/dyn3d/paramet90.h
+endif
+sed -n -e 's/^c/\!/' -e '1 h' -e '2,$ H' -e '$ { x ; s/\n     \./ \&\n     \& /g ; p }' $libf/dyn3d/control.h >! $libf/dyn3d/control.tmp
+if ( ! -f $libf/dyn3d/control.inc  || `diff $libf/dyn3d/control.tmp $libf/dyn3d/control.inc | wc -w` ) then
+      \mv $libf/dyn3d/control.tmp $libf/dyn3d/control.inc
 endif
 sed -e 's/^c/\!/' $libf/dyn3dpar/paramet.h >! $libf/dyn3dpar/paramet90.h
